#include "SevSeg.h"
#include "RTClib.h"
#include "SoftwareSerial.h"                        // библиотека для для обмена данными 
#include "DFRobotDFPlayerMini.h"                   // подключаем библиотеку для DFPlayer Mini

SevSeg sevseg;
RTC_DS3231 rtc; 
SoftwareSerial mySoftwareSerial(3, 2);             // RX, TX

DFRobotDFPlayerMini myDFPlayer;
void printDetail(uint8_t type, int value);

unsigned long last_time;                                      // Переменная для хранения времени
byte dt = 0;                                                  // Точка
 
void setup(){
   Serial.begin(9600);
   mySoftwareSerial.begin(9600);                              // открываем софт-порт
  Serial.println(F("Проверка DFPlayer ... (может пройти 3-5 секунд)"));
  
  if (!myDFPlayer.begin(mySoftwareSerial)) {                //Подключение к softwareSerial для связи с mp3.
    Serial.println(F("1.Проверьте соединение с плеером!"));
    Serial.println(F("2.Вствьте или проверьте карту!"));
    while(true){
      delay(0);                                             // Код для совместимости с ESP8266 watch dog.
    }
  }
  Serial.println(F("DFPlayer Mini online."));
    
    myDFPlayer.volume(20);                                  // устанавливаем громкость от 0 до 30
//    myDFPlayer.play(50);                                    // Приветственный звуковой файл - у меня 0050.mp3
    delay(5000);
    myDFPlayer.EQ(DFPLAYER_EQ_BASS);                        // Эквалайзер БАСЫ
  if (! rtc.begin()) {
    Serial.println("не найден RTC");
    Serial.flush();
    while (1) delay(10);
  }
//  if (rtc.lostPower()) {
//    Serial.println("RTC потерял питание, время сброшено!");
//    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
//  }
//  rtc.adjust(DateTime(__DATE__, __TIME__));                       // УСТАНОВКА ВРЕМЕНИ АВТОМАТИЧЕСКИ при компиляции
//rtc.adjust(DateTime(2000 + year, month, day, hour, minute, 0));   // УСТАНОВКА ВРЕМЕНИ АВТОМАТИЧЕСКИ 
// год месяц день  часы минуты секунды:
//  rtc.adjust(DateTime(2022, 2, 20, 12, 57, 0));                   //  Установка вручную
 
     
  byte numDigits = 4;  
  byte digitPins[] = {17, 16, 15, 14};
  byte segmentPins[] = {13, 12, 11, 10, 9, 8, 7, 6, 5};

   bool resistorsOnSegments = false;                // 'false' означает, что резисторы находятся на цифровых контактах
  byte hardwareConfig = COMMON_CATHODE;             // COMMON_ANODE
  bool updateWithDelays = false;                    // По умолчанию рекомендуется использовать 'false'
  bool leadingZeros = true;                         // Используйте 'true', если вы хотите сохранить начальные нули
  bool disableDecPoint = false;                     //Используйте "true", если ваша десятичная точка не существует или не подключена. 

  sevseg.begin(hardwareConfig, numDigits, digitPins, segmentPins, resistorsOnSegments, updateWithDelays, leadingZeros, disableDecPoint);
  
  sevseg.setBrightness(60);                         // Яркость дисплея от -200 до 200. 0 до 100-это стандартный диапазон.
  sevseg.blank();                                   // Очистить дисплей
  myDFPlayer.volume(20);
}

void loop()
{
  DateTime now = rtc.now();
    char buf1[] = "hhmm";
    String y = now.toString(buf1);
  
if(millis() - last_time > 1000) {                     // 1 секунда мигание точек
  dt = !dt;
  last_time = millis();
}
  
  sevseg.setNumber(y.toInt() ,dt);                    // sevseg.setNumber(x,0,true) - В 16-ричной системе
  sevseg.refreshDisplay(); // Обновление дисплея

//Serial.print(now.minute();
//Serial.println(now.second());
//Serial.println();

if(now.minute() == 0 && now.second() == 0) {
switch (now.hour())                                   // Каждый час кукушка будет куковать
 {
   case 1:
   myDFPlayer.volume(5);
   myDFPlayer.play(1);                                // проигрываем файл mp3/0001.mp3
   delay(1000);
   break;
   
   case 13:
   myDFPlayer.volume(10);
   myDFPlayer.play(1);
   delay(1000);                                
   break;
   
   case 2:
   myDFPlayer.volume(5);
   myDFPlayer.play(2);                                // проигрываем файл mp3/0002.mp3
   delay(1000);
   break;
   
   case 14:
   myDFPlayer.volume(10);
   myDFPlayer.play(2);                                
   delay(1000);
   break;
   
   case 3:
   myDFPlayer.volume(5);
   myDFPlayer.play(3);                                // проигрываем файл mp3/0003.mp3
   delay(1000);
   break;
   
   case 15:
   myDFPlayer.volume(10);
   myDFPlayer.play(3);                                
   delay(1000);
   break;
   
   case 4:
   myDFPlayer.volume(5);
   myDFPlayer.play(4);                                // проигрываем файл mp3/0004.mp3
   delay(1000);
   break;
   
   case 16:
   myDFPlayer.volume(10);
   myDFPlayer.play(4);                                
   delay(1000);
   break;

   case 5:
   myDFPlayer.volume(5);
   myDFPlayer.play(5);                                 // проигрываем файл mp3/0005.mp3
   delay(1000);
   break;
   
   case 17:
   myDFPlayer.volume(10);
   myDFPlayer.play(5);                                 
   delay(1000);
   break;
   
   case 6:
   myDFPlayer.volume(5);
   myDFPlayer.play(6);                                 // проигрываем файл mp3/0006.mp3   
   delay(1000);
   break;
   
   case 18:
   myDFPlayer.volume(10);
   myDFPlayer.play(6);                                   
   delay(1000);
   break;

   case 7:
   myDFPlayer.volume(5);
   myDFPlayer.play(7);                                 // проигрываем файл mp3/0007.mp3
   delay(1000);
   break;
   
   case 19:
   myDFPlayer.volume(10);
   myDFPlayer.play(7);                                 
   delay(1000);
   break;

   case 8:
   myDFPlayer.volume(5);
   myDFPlayer.play(8);                                 // проигрываем файл mp3/0008.mp3
   delay(1000);
   break;
   
   case 20:
   myDFPlayer.volume(10);
   myDFPlayer.play(8);                                 
   delay(1000);
   break;
  
   case 9:
   myDFPlayer.volume(5);
   myDFPlayer.play(9);                                 // проигрываем файл mp3/0009.mp3
   delay(1000);
   break;
   
   case 21:
   myDFPlayer.volume(10);
   myDFPlayer.play(9);                                 
   delay(1000);
   break;

   case 10:
   case 22:
   myDFPlayer.play(10);                                // проигрываем файл mp3/0010.mp3
   delay(1000);
   break;
   
   case 11:
   myDFPlayer.volume(10);
   myDFPlayer.play(11);                                // проигрываем файл mp3/0011.mp3
   delay(1000);
   break;
   
   case 23:
   myDFPlayer.volume(5);
   myDFPlayer.play(11);                                
   delay(1000);
   break;
   
   case 12:
   myDFPlayer.volume(10);
   myDFPlayer.play(12);                                 // проигрываем файл mp3/0012.mp3
   delay(1000);
   break;
   
   case 0:
   myDFPlayer.volume(5);
   myDFPlayer.play(12);                                 
   delay(1000);
   break;
  
   default:
   {  }
  }                 
 }
}
